import { DataResult, ViewResult } from './result';
import { ResourceDataRouteDefinition, ResourceDefinition, ResourceMethodMap, ResourceRouteHandler, ResourceViewRouteDefinition, UnthinkCommonMiddleware, UnthinkDataMiddleware, UnthinkMiddleware, UnthinkMiddlewareHandler, UnthinkViewMiddleware } from './resource-definition';
export interface ResourceRouteConfig<ResourceMiddleware> {
    prefix?: string;
    routeId?: string;
    middleware?: ResourceMiddleware[];
}
export declare function data<ResourceMiddleware>(path: string, methods: ResourceMethodMap<DataResult, ResourceMiddleware>, config?: ResourceRouteConfig<ResourceMiddleware>): ResourceDataRouteDefinition<ResourceMiddleware>;
export declare function view<ResourceMiddleware>(path: string, handler: string | ResourceRouteHandler<ViewResult, ResourceMiddleware>, config?: ResourceRouteConfig<ResourceMiddleware>): ResourceViewRouteDefinition<ResourceMiddleware>;
export declare function agnosticMiddleware(func: UnthinkMiddlewareHandler): UnthinkCommonMiddleware;
export declare function dataMiddleware(func: UnthinkMiddlewareHandler): UnthinkDataMiddleware;
export declare function viewMiddleware(func: UnthinkMiddlewareHandler): UnthinkViewMiddleware;
export declare function unthinkResource(resourceDefinition: ResourceDefinition<UnthinkMiddleware>): ResourceDefinition<UnthinkMiddleware>;
