"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const result_1 = require("./result");
const resource_definition_1 = require("./resource-definition");
function data(path, methods, config = {}) {
    if (!config.prefix) {
        config.prefix = '/api';
    }
    return {
        __routeType: resource_definition_1.RouteType.DATA,
        path: path,
        methods: methods,
        prefix: config.prefix,
        middleware: config.middleware
    };
}
exports.data = data;
function view(path, handler, config = {}) {
    let methodMap;
    if (typeof handler === 'string') {
        methodMap = {
            'get': async () => result_1.ViewResult.ok(handler)
        };
    }
    else {
        methodMap = {
            'get': handler
        };
    }
    return {
        __routeType: resource_definition_1.RouteType.VIEW,
        path: path,
        methods: methodMap,
        prefix: config.prefix,
        middleware: config.middleware
    };
}
exports.view = view;
function agnosticMiddleware(func) {
    const commonMiddlewareHandler = func;
    commonMiddlewareHandler.__middlewareType = resource_definition_1.MiddlewareType.COMMON;
    return commonMiddlewareHandler;
}
exports.agnosticMiddleware = agnosticMiddleware;
function dataMiddleware(func) {
    const dataMiddlewareHandler = func;
    dataMiddlewareHandler.__middlewareType = resource_definition_1.MiddlewareType.DATA;
    return dataMiddlewareHandler;
}
exports.dataMiddleware = dataMiddleware;
function viewMiddleware(func) {
    const viewMiddlewareHandler = func;
    viewMiddlewareHandler.__middlewareType = resource_definition_1.MiddlewareType.VIEW;
    return viewMiddlewareHandler;
}
exports.viewMiddleware = viewMiddleware;
function unthinkResource(resourceDefinition) {
    return resourceDefinition;
}
exports.unthinkResource = unthinkResource;
//# sourceMappingURL=builder-functions.js.map