import { UnthinkMiddleware, ResourceDefinition, RouteContext } from './resource-definition';
import { Result } from './result';
export interface UnthinkViewRenderer {
    (result: Result, routeContext: RouteContext): string;
}
export interface UnthinkGeneratorBackend {
    generate(resourceDefinitions: ResourceDefinition<UnthinkMiddleware>[]): void;
}
export declare class UnthinkGenerator {
    private resourceDefinitions;
    private generatorBackend;
    constructor(generatorBackend: UnthinkGeneratorBackend);
    add(resourceDefinition: ResourceDefinition<UnthinkMiddleware>): UnthinkGenerator;
    printRouteTable(): void;
    generate(): void;
}
