"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
class UnthinkGenerator {
    constructor(generatorBackend) {
        this.resourceDefinitions = [];
        this.generatorBackend = generatorBackend;
    }
    add(resourceDefinition) {
        this.resourceDefinitions.push(resourceDefinition);
        return this;
    }
    printRouteTable() {
        var _a, _b;
        const tab = '    ';
        console.log('Route Table:');
        for (const resd of this.resourceDefinitions) {
            const basePath = (_a = resd.basePath) !== null && _a !== void 0 ? _a : '/';
            console.log(`${tab}Resource: ${resd.name} - ${basePath}`);
            for (const rd of resd.routes) {
                const prefix = (_b = rd.prefix) !== null && _b !== void 0 ? _b : '';
                for (const m in rd.methods) {
                    const fullPath = path.join(prefix, basePath, rd.path);
                    console.log(`${tab}${tab}${m.toUpperCase()} ${rd.__routeType} ${fullPath}`);
                }
            }
        }
        console.log();
    }
    generate() {
        this.generatorBackend.generate(this.resourceDefinitions);
    }
}
exports.UnthinkGenerator = UnthinkGenerator;
//# sourceMappingURL=unthink-generator.js.map